<template>
	<v-container class="admin" :class="{ 'px-0': $vuetify.breakpoint.smAndDown }">
		<v-container class="d-flex justify-space-between align-end">
			<h3>Fields</h3>
		</v-container>
		<v-skeleton-loader v-if="isLoading" type="card" />
		<v-card v-if="!isLoading" rounded="lg" class="overflow-hidden">
			<v-card-text v-if="hasError"> There was an error loading resources. Please refresh. </v-card-text>
			<v-card-text v-else-if="fields.length === 0 && !hasError"> You do not have access to any fields. </v-card-text>
			<v-list v-else>
				<v-list-item-group>
					<v-list-item
						active-class="primary--text text--accent-4"
						three-line
						v-for="field in fields"
						:key="field.id"
						:value="field.id"
					>
						<admin-field-list-item-content
							:field="field"
							:group="groups.find((group) => group.id === field.meta.groupId)"
						/>
						<v-list-item-action>
							<field-reassign :field="field" :groups="groups" />
						</v-list-item-action>
					</v-list-item>
				</v-list-item-group>
			</v-list>
		</v-card>
	</v-container>
</template>

<script lang="ts">
import { defineComponent, computed } from '@vue/composition-api';
import { useGroups } from '@/store/modules/group';
import { useAllResources } from '@/store/modules/resources';
import AdminFieldListItemContent from './AdminFieldListItemContent.vue';
import FieldReassign from './FieldReassign.vue';

export default defineComponent({
	components: {
		AdminFieldListItemContent,
		FieldReassign,
	},
	setup(_, { root }) {
		const {
			isLoading: resourcesAreLoading,
			isLoaded: resourcesAreLoaded,
			hasError: resourcesHaveError,
			fields,
		} = useAllResources(root.$store);
		const { isLoading: groupsAreLoading, isLoaded: groupsAreLoaded, hasError: groupsHaveError, groups } = useGroups(
			root.$store
		);

		const isLoaded = computed(() => resourcesAreLoaded.value && groupsAreLoaded.value);

		const isLoading = computed(() => [resourcesAreLoading.value, groupsAreLoading.value].some(Boolean));

		const hasError = computed(() => [resourcesHaveError.value, groupsHaveError.value].some(Boolean));

		return {
			isLoaded,
			isLoading,
			hasError,
			fields,
			groups,
		};
	},
});
</script>

<style></style>
